<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  CTA as CallToAction,
  Copy,
  CopyMedia,
  AnchorDropdown,
} from '../components/common/index.vue';
import { getHelpDataHelper } from '../services/get-help.service';
import { CONTENT_TYPES } from '../common/content-types';
import { MenuComponent as SideMenu } from '~/components/side-menu/index.vue';
import { getPageMetadata } from '~/common/meta';
import { getClient } from '~/plugins/contentful.js';

export default Vue.extend({
  name: 'GetHelp',
  components: {
    AnchorDropdown,
    CallToAction,
    Copy,
    CopyMedia,
    SideMenu,
  },
  nuxtI18n: false,
  async asyncData({ error }: any) {
    try {
      const response = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'get-help',
        include: 3,
      });

      const { pageContent } = response.items[0].fields;
      const seoMetadata = response.items[0].fields.seoMetadata[0].fields;

      const doc = getHelpDataHelper(pageContent);
      const metadata = {
        title: seoMetadata.title,
        description: seoMetadata.description,
        og_title: seoMetadata.title,
        og_description: seoMetadata.description,
      };
      return { doc, metadata };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).metadata, this.$route.path);
  },
  mounted() {
    const { sideMenu } = this.$refs;
    document.addEventListener('scroll', () => {
      if (window.scrollY >= 4380) {
        sideMenu.$el.style.display = 'none';
      } else sideMenu.$el.style.display = 'block';
    });
  },
});
</script>

<template>
  <SlpContainer>
    <SideMenu
      v-if="doc.side_menu"
      ref="sideMenu"
      :links="doc.side_menu.links"
    />
    <anchor-dropdown
      :options="doc.side_menu.links"
      fixed
      label="On this page: "
    />
    <SlpColumn :cols="10" size="xl">
      <component
        :is="component.name"
        v-for="component in doc.components"
        :key="component.name"
        :data="component.data"
      />
    </SlpColumn>
  </SlpContainer>
</template>

<style scoped lang="scss"></style>
